/*
Code automatically generated by asn1scc tool
*/
#include <limits.h>
#include <string.h>
#include <math.h>
#include "record.h"




void asn1SccRecord_Initialize(asn1SccRecord* pVal)
{


	/*set ids */
	asn1SccInt64Sequence_Initialize((&(pVal->ids)));
	/*set strings */
	asn1SccStringSequence_Initialize((&(pVal->strings)));
}

flag asn1SccRecord_IsConstraintValid(const asn1SccRecord *pVal, int* pErrCode)
{
    flag ret = TRUE;
    int i1;
	
    ret = ((0 <= pVal->ids.nCount) && (pVal->ids.nCount <= 327680));
    *pErrCode = ret ? 0 :  ERR_RECORD_IDS;
    for(i1 = 0; ret && i1 < pVal->ids.nCount; i1++) 
    {
    	ret = (-9223372036854775807LL <= pVal->ids.arr[i1]);
    	*pErrCode = ret ? 0 :  ERR_RECORD_IDS_ELM;
    }

    if (ret) {
        ret = ((0 <= pVal->strings.nCount) && (pVal->strings.nCount <= 100));
        *pErrCode = ret ? 0 :  ERR_RECORD_STRINGS;
        for(i1 = 0; ret && i1 < pVal->strings.nCount; i1++) 
        {
        	ret = ((0 <= pVal->strings.arr[i1].nCount) && (pVal->strings.arr[i1].nCount <= 256));
        	*pErrCode = ret ? 0 :  ERR_RECORD_STRINGS_ELM;
        }

    }

	return ret;
}

flag asn1SccRecord_Encode(const asn1SccRecord* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
	ret = bCheckConstraints ? asn1SccRecord_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    /*Encode ids */
	    ret = asn1SccInt64Sequence_Encode((&(pVal->ids)), pBitStrm, pErrCode, FALSE);
	    if (ret) {
	        /*Encode strings */
	        ret = asn1SccStringSequence_Encode((&(pVal->strings)), pBitStrm, pErrCode, FALSE);
	    }
    }

	
    return ret;
}

flag asn1SccRecord_Decode(asn1SccRecord* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	/*Decode ids */
	ret = asn1SccInt64Sequence_Decode((&(pVal->ids)), pBitStrm, pErrCode);
	if (ret) {
	    /*Decode strings */
	    ret = asn1SccStringSequence_Decode((&(pVal->strings)), pBitStrm, pErrCode);
	}

	return ret  && asn1SccRecord_IsConstraintValid(pVal, pErrCode);
}

flag asn1SccRecord_ACN_Encode(const asn1SccRecord* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
	int i1;
	asn1SccSint nBlockIndex1;
	asn1SccSint nRemainingItemsVar1;
	asn1SccSint nCurBlockSize1;
	asn1SccSint nCurOffset1;
	int i2;
	ret = bCheckConstraints ? asn1SccRecord_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    /*Encode ids */
	    nRemainingItemsVar1 = pVal->ids.nCount;
	    nCurBlockSize1 = 0;
	    nCurOffset1 = 0;
	    nBlockIndex1 = 0;
	    while (nRemainingItemsVar1 >= 0x4000 && nBlockIndex1 < pVal->ids.nCount) 
	    {
	    	if (nRemainingItemsVar1 >= 0x10000)
	    	{
	    		nCurBlockSize1 = 0x10000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC4, 0, 0xFF); 
	    	}
	    	else if (nRemainingItemsVar1 >= 0xC000)
	    	{
	    		nCurBlockSize1 = 0xC000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC3, 0, 0xFF); 
	    	}
	    	else if (nRemainingItemsVar1 >= 0x8000)
	    	{
	    		nCurBlockSize1 = 0x8000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC2, 0, 0xFF); 
	    	}
	    	else 
	    	{
	    		nCurBlockSize1 = 0x4000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC1, 0, 0xFF); 
	    	}
	    	
	    	for(i1=(int)nCurOffset1; i1 < (int)(nCurBlockSize1 + nCurOffset1); i1++)
	    	{
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, pVal->ids.arr[i1], -9223372036854775807LL, 9223372036854775807LL);
	    	}
	    	nCurOffset1 += nCurBlockSize1;
	    	nRemainingItemsVar1 -= nCurBlockSize1;
	        nBlockIndex1 = nBlockIndex1+1;
	    }

	    if (nRemainingItemsVar1 <= 0x7F)
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, nRemainingItemsVar1, 0, 0xFF);
	    else
	    {
	    	BitStream_AppendBit(pBitStrm, 1);
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, nRemainingItemsVar1, 0, 0x7FFF);
	    }

	    for(i1=(int)nCurOffset1; i1 < (int)(nCurOffset1 + nRemainingItemsVar1); i1++)
	    {
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, pVal->ids.arr[i1], -9223372036854775807LL, 9223372036854775807LL);
	    }
	    if (ret) {
	        /*Encode strings */
	        BitStream_EncodeConstraintWholeNumber(pBitStrm, pVal->strings.nCount, 0, 100);
	        	
	        for(i1=0; (i1 < (int)pVal->strings.nCount) && ret; i1++) 
	        {
	        	BitStream_EncodeConstraintWholeNumber(pBitStrm, pVal->strings.arr[i1].nCount, 0, 256);
	        		
	        	for(i2=0; (i2 < (int)pVal->strings.arr[i1].nCount) && ret; i2++) 
	        	{
	        		BitStream_AppendByte0(pBitStrm, pVal->strings.arr[i1].arr[i2]);
	        	}
	        }
	    }
    }

	
    return ret;
}

flag asn1SccRecord_ACN_Decode(asn1SccRecord* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;
	int i1;
	asn1SccSint nLengthTmp1;
	asn1SccSint nRemainingItemsVar1;
	asn1SccSint nCurBlockSize1;
	asn1SccSint nCurOffset1;
	int i2;
	asn1SccSint nCount;

	/*Decode ids */
	nRemainingItemsVar1 = 0;
	nCurBlockSize1 = 0;
	nCurOffset1 = 0;
	nLengthTmp1 = 0;
	ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nRemainingItemsVar1, 0, 0xFF);
	*pErrCode = ret ? 0 : ERR_ACN_DECODE_RECORD_IDS;
	if (ret) {
		while(ret && (nRemainingItemsVar1 & 0xC0)==0xC0) 
		{
			if (nRemainingItemsVar1 == 0xC4)
				nCurBlockSize1 = 0x10000;
			else if (nRemainingItemsVar1 == 0xC3)
				nCurBlockSize1 = 0xC000;
			else if (nRemainingItemsVar1 == 0xC2)
				nCurBlockSize1 = 0x8000;
			else if (nRemainingItemsVar1 == 0xC1)
				nCurBlockSize1 = 0x4000;
			else {
				*pErrCode = ERR_ACN_DECODE_RECORD_IDS;
				return FALSE;
			}
			if (nCurOffset1 + nCurBlockSize1 > 327680)
			{
				*pErrCode = ERR_ACN_DECODE_RECORD_IDS;
				return FALSE;
			}

			for(i1=(int)nCurOffset1; ret && (i1 < (int)(nCurOffset1 + nCurBlockSize1)) ; i1++)
			{
				ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, (&(pVal->ids.arr[i1])), -9223372036854775807LL, 9223372036854775807LL);
				*pErrCode = ret ? 0 : ERR_ACN_DECODE_RECORD_IDS_ELM;
			}
		
	        if (ret) {
			    nLengthTmp1 += (long)nCurBlockSize1;
			    nCurOffset1 += nCurBlockSize1;
			    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nRemainingItemsVar1, 0, 0xFF);
	            *pErrCode = ret ? 0 : ERR_ACN_DECODE_RECORD_IDS;
	        }
		}
	    if (ret) {
		    if ( (nRemainingItemsVar1 & 0x80)>0) 
		    {
			    asn1SccSint len2;
			    nRemainingItemsVar1 <<= 8;
			    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &len2, 0, 0xFF);
	            *pErrCode = ret ? 0 : ERR_ACN_DECODE_RECORD_IDS;
	            if (ret) {
			        nRemainingItemsVar1 |= len2;
			        nRemainingItemsVar1 &= 0x7FFF;
	            }
		    }
	        ret = ret && (nCurOffset1 + nRemainingItemsVar1 <= 327680);
	        *pErrCode = ret ? 0 : ERR_ACN_DECODE_RECORD_IDS;
	        if (ret) {
		        for(i1=(int)nCurOffset1; ret && (i1 < (int)(nCurOffset1 + nRemainingItemsVar1)) ; i1++)
		        {
			        ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, (&(pVal->ids.arr[i1])), -9223372036854775807LL, 9223372036854775807LL);
			        *pErrCode = ret ? 0 : ERR_ACN_DECODE_RECORD_IDS_ELM;
		        }
	            if (ret) {
		            nLengthTmp1 += (long)nRemainingItemsVar1;

	                if ((nLengthTmp1 >= 0) && (nLengthTmp1 <= 327680)) {
		                pVal->ids.nCount = (int)nLengthTmp1;

	                } else {
	                    ret = FALSE;
	                    *pErrCode = ERR_ACN_DECODE_RECORD_IDS;
	                }

	            }
	        }
	    }
	}
	if (ret) {
	    /*Decode strings */
	    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nCount, 0, 100);
	    *pErrCode = ret ? 0 : ERR_ACN_DECODE_RECORD_STRINGS;
	    pVal->strings.nCount = (long)nCount;
	    	
	    for(i1=0; (i1 < (int)pVal->strings.nCount) && ret; i1++) 
	    {
	    	ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nCount, 0, 256);
	    	*pErrCode = ret ? 0 : ERR_ACN_DECODE_RECORD_STRINGS_ELM;
	    	pVal->strings.arr[i1].nCount = (long)nCount;
	    		
	    	for(i2=0; (i2 < (int)pVal->strings.arr[i1].nCount) && ret; i2++) 
	    	{
	    		ret = BitStream_ReadByte(pBitStrm, &(pVal->strings.arr[i1].arr[i2])); 
	    		*pErrCode = ret ? 0 : ERR_ACN_DECODE_RECORD_STRINGS_ELM;
	    	}
	    }
	}

    return ret && asn1SccRecord_IsConstraintValid(pVal, pErrCode);
}

